<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Spawner Features &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="System Structure and Parameterization (SSP)" href="system_structure_and_parameterization_%28SSP%29.html" />
    <link rel="prev" title="Simulation" href="simulation.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Spawner Features</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#prerunspawner">PreRunSpawner</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#spawning-on-roads-lanes-and-ranges">Spawning on roads, lanes and ranges</a></li>
<li class="toctree-l4"><a class="reference internal" href="#traffic-parameters">Traffic parameters</a></li>
<li class="toctree-l4"><a class="reference internal" href="#stochastics">Stochastics</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#runtimespawner">RuntimeSpawner</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#id2">Spawning on roads, lanes and ranges</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id8">Traffic parameters</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id11">Stochastics</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">Spawner Features</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/spawner_features.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="spawner-features">
<span id="id1"></span><h1>Spawner Features<a class="headerlink" href="#spawner-features" title="Link to this heading"></a></h1>
<section id="prerunspawner">
<span id="spawner-features-prerun"></span><h2>PreRunSpawner<a class="headerlink" href="#prerunspawner" title="Link to this heading"></a></h2>
<section id="spawning-on-roads-lanes-and-ranges">
<h3>Spawning on roads, lanes and ranges<a class="headerlink" href="#spawning-on-roads-lanes-and-ranges" title="Link to this heading"></a></h3>
<section id="non-existent-roads">
<h4>Non-existent roads<a class="headerlink" href="#non-existent-roads" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>Road IDs specified in the configuration, but not part of the scenery file are igored.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerPreRunCommonParameterExtractor_GetWayToNextRoad_NoPossibleWay</p>
</dd>
</dl>
</section>
<section id="single-road">
<span id="spawner-features-prerun-on-roads-single-road"></span><h4>Single road<a class="headerlink" href="#single-road" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>Spawning on the given road takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>No agents are spawned on other roads in the scenery.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_Highway_SingleRoad</p>
</dd>
</dl>
</section>
<section id="consecutive-roads">
<span id="spawner-features-prerun-on-roads-consecutive-roads"></span><h4>Consecutive roads<a class="headerlink" href="#consecutive-roads" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Spawner configuration specifies a list of consecutively connected roads in a single ListItem.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>No agents spawned on other roads in the scenery.</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned on all drivable lanes (which are part of the roads being specified in the configuration).</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned in the correct driving direction.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_Highway_FullStream
End-to-end Test SpawnerPreRun_SingleRoad_DrivingDirection</p>
</dd>
</dl>
</section>
<section id="non-consecutive-roads">
<h4>Non-consecutive roads<a class="headerlink" href="#non-consecutive-roads" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Spawner configuration specifies a list of non-consecutively connected roads.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>Missing roads between the specified ones are automatically determined by the Spawner and handled like they were specified in the configuration in the first place.
The resulting path being spawned on is arbitrary if multiple solutions exist for a scenery, but only one path shall be used.</p>
</dd>
<dt>Verified by</dt><dd><p>Covered by <a class="reference internal" href="#spawner-features-prerun-on-roads-across-junction"><span class="std std-ref">Roads across junction</span></a></p>
</dd>
</dl>
</section>
<section id="roads-across-junction">
<span id="spawner-features-prerun-on-roads-across-junction"></span><h4>Roads across junction<a class="headerlink" href="#roads-across-junction" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Spawner configuration specifies a list of (not necessarily consecutively) connected roads in a single ListItem.</p>
</dd>
<dt>Precondition</dt><dd><p>The chain of roads specified has to cross a single junction.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>Missing roads between the specified ones are automatically determined by the Spawner and handled like they were specified in the configuration in the first place.
The resulting path being spawned on is arbitrary if multiple solutions exist for a scenery, but only one path shall be used.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_Highway_EntryExit</p>
</dd>
</dl>
</section>
<section id="multiple-roads-including-non-existent-ids">
<h4>Multiple roads (including non existent IDs)<a class="headerlink" href="#multiple-roads-including-non-existent-ids" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Spawner configuration specifies a list of (at least partially) consecutively connected roads in a single ListItem.</p>
</dd>
<dt>Precondition</dt><dd><p>At least one road id given in the configuration is not present in the scenery.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads takes place up to the first non-existent road that is encountered.</p>
</dd>
<dt>Requirement</dt><dd><p>No spawning takes place, if the first road of the list doesn’t exist.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_Highway_IncorrectStreamBegin
End-to-end Test SpawnerPreRun_Highway_IncorrectStreamMid</p>
</dd>
</dl>
</section>
<section id="specified-lanes">
<h4>Specified lanes<a class="headerlink" href="#specified-lanes" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>A list of lanes to be spawned on is specified in the Spawner configuration.</p>
</dd>
<dt>Precondition</dt><dd><p>The list of lanes contains at least one lane IDs which exist for the first specified road.</p>
</dd>
<dt>Precondition</dt><dd><p>The list of lanes contains at least one lane IDs which doesn’t exist for the first specified road.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the specified lane IDs (on drivable lanes).</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning does not take place on other lane IDs.</p>
</dd>
<dt>Requirement</dt><dd><p>Lane IDs not present for one or more roads do not lead to an error.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_SingleRoad_SpecifiedLanes</p>
</dd>
</dl>
</section>
<section id="multiple-overlapping-road-streams">
<h4>Multiple overlapping road streams<a class="headerlink" href="#multiple-overlapping-road-streams" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Two road streams are specified in the Spawner configuration (as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>).</p>
</dd>
<dt>Precondition</dt><dd><p>The two road streams have at least one road in common.</p>
</dd>
<dt>Precondition</dt><dd><p>The Spawner configuration specifies the lanes to spawn on in such a way that there are no overlapping lanes (on the road being common to both streams).</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads and all given lanes takes place.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_Highway_RoadOverlap</p>
</dd>
</dl>
</section>
<section id="spawning-on-range-sstart-send-within-road-boundaries">
<h4>Spawning on range (SStart + SEnd within road boundaries)<a class="headerlink" href="#spawning-on-range-sstart-send-within-road-boundaries" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>SStart and SEnd are set to values within the road boundaries (with the effective start s-coordinate being lower than the effective end s-coordinate when taking the whole road stream into account).</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned within the specified range.</p>
</dd>
<dt>Requirement</dt><dd><p>No agents are spawned outside of the specified range.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerPreRunCommonParameterExtractor_ExtractSpawnAreas_AllOptionalParameters
End-to-end Test SpawnerPreRun_SingleRoad_SpecifiedRange</p>
</dd>
</dl>
</section>
<section id="spawning-on-range-sstart-slength-within-road-boundaries">
<h4>Spawning on range (SStart + SLength within road boundaries)<a class="headerlink" href="#spawning-on-range-sstart-slength-within-road-boundaries" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>SStart and SLength are set to values within the road boundaries (with the effective start s-coordinate being lower than the effective end s-coordinate when taking the whole road stream into account).</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned within the specified range.</p>
</dd>
<dt>Requirement</dt><dd><p>No agents are spawned outside of the specified range.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerPreRunCommonParameterExtractor_ExtractSpawnAreas_AllOptionalParameters</p>
</dd>
</dl>
</section>
<section id="spawning-on-range-send-outside-of-road-boundaries">
<h4>Spawning on range (SEnd outside of road boundaries)<a class="headerlink" href="#spawning-on-range-send-outside-of-road-boundaries" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>SStart is set set to a value within the road boundaries, SEnd is set greater than the length of the last road given.</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned within the specified range.</p>
</dd>
<dt>Requirement</dt><dd><p>The specified range is capped to the length of the last road.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerPreRunCommonParameterExtractor_ExtractSpawnAreasWithSOutOfRange_ReturnsValidS</p>
</dd>
</dl>
</section>
<section id="spawning-on-range-slength-outside-of-road-boundaries">
<h4>Spawning on range (SLength outside of road boundaries)<a class="headerlink" href="#spawning-on-range-slength-outside-of-road-boundaries" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>SStart is set set to a value within the road boundaries, SLength is set greater than the accumulated length of all roads given.</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned within the specified range.</p>
</dd>
<dt>Requirement</dt><dd><p>The specified range is capped to the length of the roads.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerPreRunCommonParameterExtractor_ExtractSpawnAreasWithSOutOfRange_ReturnsValidS</p>
</dd>
</dl>
</section>
<section id="right-lane-only">
<h4>Right lane only<a class="headerlink" href="#right-lane-only" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-consecutive-roads"><span class="std std-ref">Consecutive roads</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">RightLaneOnly</span></code> set to <code class="docutils literal notranslate"><span class="pre">true</span></code> in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the specified roads.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the rightmost lanes only.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerPreRun_SingleRoad_RightLaneOnly</p>
</dd>
</dl>
</section>
</section>
<section id="traffic-parameters">
<h3>Traffic parameters<a class="headerlink" href="#traffic-parameters" title="Link to this heading"></a></h3>
<section id="separation-buffer-specified">
<h4>Separation buffer specified<a class="headerlink" href="#separation-buffer-specified" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">MinimumSeparationBuffer</span></code> is set in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>No two agents are spawned with a net distance lower than the specified separation buffer.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="separation-buffer-not-specified">
<h4>Separation buffer not specified<a class="headerlink" href="#separation-buffer-not-specified" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">MinimumSeparationBuffer</span></code> is not set in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>No two agents are spawned with a net distance lower than 5 m.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="time-to-collision">
<h4>Time to collision<a class="headerlink" href="#time-to-collision" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-prerun-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Requirement</dt><dd><p>No agent is spawned with a TTC lower than the configured threshold (with respect to end of lane).</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED
Also has to be checked by analysis of simulation output by an external tool</p>
</dd>
</dl>
</section>
</section>
<section id="stochastics">
<h3>Stochastics<a class="headerlink" href="#stochastics" title="Link to this heading"></a></h3>
<section id="traffic-groups">
<h4>Traffic groups<a class="headerlink" href="#traffic-groups" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The selection of traffic groups is randomized using a uniform distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="agent-profiles">
<h4>Agent profiles<a class="headerlink" href="#agent-profiles" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The selection of agent profiles is randomized using a uniform distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="velocity-distribution">
<h4>Velocity distribution<a class="headerlink" href="#velocity-distribution" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The distribution of the velocities of a traffic group has to match the configured distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED
Also has to be checked by analysis of simulation output by an external tool</p>
</dd>
</dl>
</section>
<section id="tgap-distribution">
<h4>TGap distribution<a class="headerlink" href="#tgap-distribution" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The distribution of the TGaps of a traffic group has to match the configured distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED
Also has to be checked by analysis of simulation output by an external tool</p>
</dd>
</dl>
</section>
</section>
</section>
<section id="runtimespawner">
<span id="spawner-features-runtime"></span><h2>RuntimeSpawner<a class="headerlink" href="#runtimespawner" title="Link to this heading"></a></h2>
<section id="id2">
<h3>Spawning on roads, lanes and ranges<a class="headerlink" href="#id2" title="Link to this heading"></a></h3>
<section id="id3">
<h4>Non-existent roads<a class="headerlink" href="#id3" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>Road IDs specified in the configuration, but not part of the scenery file are igored.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="spawner-features-runtime-on-roads-single-road">
<span id="id4"></span><h4>Single road<a class="headerlink" href="#spawner-features-runtime-on-roads-single-road" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>Spawning on the given road takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>No agents are spawned on other roads in the scenery.</p>
</dd>
<dt>Requirement</dt><dd><p>Agents are spawned in the correct driving direction.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerRuntime_Highway_SingleRoad</p>
</dd>
</dl>
</section>
<section id="driving-direction">
<h4>Driving direction<a class="headerlink" href="#driving-direction" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>Agents are spawned in the correct driving direction (matching lane direction).</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerRuntime_Highway_SingleRoad_DrivingDirection</p>
</dd>
</dl>
</section>
<section id="id5">
<h4>Multiple roads (including non existent IDs)<a class="headerlink" href="#id5" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Spawner configuration specifies a list of roads in a single ListItem.</p>
</dd>
<dt>Precondition</dt><dd><p>At least one road id given in the configuration is not present in the scenery.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning on the given roads takes place.</p>
</dd>
<dt>Requirement</dt><dd><p>Non-existent road IDs are ignored.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerRuntime_Highway_MultipleRoads</p>
</dd>
</dl>
</section>
<section id="id6">
<h4>Specified lanes<a class="headerlink" href="#id6" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-runtime-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p>A list of lanes to be spawned on is specified in the Spawner configuration.</p>
</dd>
<dt>Precondition</dt><dd><p>The list of lanes contains lane IDs which don’t exist for the specified road.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the specified lane IDs (on drivable lanes).</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning does not take place on other lane IDs.</p>
</dd>
<dt>Requirement</dt><dd><p>Lane IDs not present for the specified road do not lead to an error.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerRuntime_SingleRoad_SpecifiedLanes</p>
</dd>
</dl>
</section>
<section id="id7">
<h4>Right lane only<a class="headerlink" href="#id7" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-runtime-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">RightLaneOnly</span></code> set to <code class="docutils literal notranslate"><span class="pre">true</span></code> in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the specified road.</p>
</dd>
<dt>Requirement</dt><dd><p>Spawning takes place on the rightmost lane only.</p>
</dd>
<dt>Verified by</dt><dd><p>End-to-end Test SpawnerRuntime_SingleRoad_RightLaneOnly</p>
</dd>
</dl>
</section>
</section>
<section id="id8">
<h3>Traffic parameters<a class="headerlink" href="#id8" title="Link to this heading"></a></h3>
<section id="id9">
<h4>Separation buffer specified<a class="headerlink" href="#id9" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-runtime-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">MinimumSeparationBuffer</span></code> is set in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>No two agents are spawned with a net distance lower than the specified separation buffer.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerRuntimeCommonParameterExtractor_ExtractMinimumSeparationBuffer_FixedValue</p>
</dd>
</dl>
</section>
<section id="id10">
<h4>Separation buffer not specified<a class="headerlink" href="#id10" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Precondition</dt><dd><p>Basic setup as as in <a class="reference internal" href="#spawner-features-runtime-on-roads-single-road"><span class="std std-ref">Single road</span></a>.</p>
</dd>
<dt>Precondition</dt><dd><p><code class="docutils literal notranslate"><span class="pre">MinimumSeparationBuffer</span></code> is not set in the Spawner configuration.</p>
</dd>
<dt>Requirement</dt><dd><p>No two agents are spawned with a net distance lower than 5 m.</p>
</dd>
<dt>Verified by</dt><dd><p>Unit Test SpawnerRuntimeCommonParameterExtractor_ExtractMinimumSeparationBuffer_NoValue_SetsDefault</p>
</dd>
</dl>
</section>
</section>
<section id="id11">
<h3>Stochastics<a class="headerlink" href="#id11" title="Link to this heading"></a></h3>
<section id="id12">
<h4>Traffic groups<a class="headerlink" href="#id12" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The selection of traffic groups is randomized using a uniform distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="id13">
<h4>Agent profiles<a class="headerlink" href="#id13" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The selection of agent profiles is randomized using a uniform distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED</p>
</dd>
</dl>
</section>
<section id="id14">
<h4>Velocity distribution<a class="headerlink" href="#id14" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The distribution of the velocities of a traffic group has to match the configured distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED
Also has to be checked by analysis of simulation output by an external tool</p>
</dd>
</dl>
</section>
<section id="id15">
<h4>TGap distribution<a class="headerlink" href="#id15" title="Link to this heading"></a></h4>
<dl class="simple">
<dt>Requirement</dt><dd><p>The distribution of the TGaps of a traffic group has to match the configured distribution.</p>
</dd>
<dt>Verified by</dt><dd><p>UNTESTED
Also has to be checked by analysis of simulation output by an external tool</p>
</dd>
</dl>
</section>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="simulation.html" class="btn btn-neutral float-left" title="Simulation" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="system_structure_and_parameterization_%28SSP%29.html" class="btn btn-neutral float-right" title="System Structure and Parameterization (SSP)" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>